#include <iostream>
#include <math.h>
using namespace std;
int razlika(int broj1, int broj2)
{
    int rez = abs(broj1-broj2);
    return rez;
}
int racunanjekrozniz(int niz[], int n, int maksi,int mini, int brojmaksi, int brojmini, int rez, int maksirazlika)
{

    for (int i = 0;i<n;i++)
        {
            if (niz[i]==maksi)
            {
                brojmaksi--;
                if (brojmaksi>0)
                {
                    if (razlika(maksi,rez)>maksirazlika)
                    {
                        rez = razlika(maksi,rez);
                        maksirazlika = rez;
                    }
                }

            }
            if (niz[i]==mini)
            {
                brojmini--;
                if (brojmini>0)
                {
                    if (razlika(mini,rez)>maksirazlika)
                    {
                        rez = razlika(mini,rez);
                        maksirazlika = rez;
                    }
                }
            }
            if (niz[i]!=mini && niz[i]!=maksi)
            {
                if (razlika(niz[i],rez)>maksirazlika)
                    {
                        rez = razlika(niz[i],rez);
                        maksirazlika = rez;
                    }
            }

        }
        return maksirazlika;
}
int main()
{
    int n,bira;
    cin >> n>>bira;
    int niz[n];
    int maksi = -1;
    int mini = INT_MAX;
    int rez;
    int maksirazlika = INT_MIN;
    int brojmaksi=0;
    int brojmini=0;
    for (int i = 0; i<n;i++)
    {
        cin >> niz[i];
        if (niz[i]>maksi)
        {
            maksi = niz[i];

        }
        if (niz[i]<mini)
        {
            mini = niz[i];

        }
    }
    for (int s = 0; s<n;s++)
    {
        if(niz[s]==maksi)
            brojmaksi++;
        if (niz[s]==mini)
            brojmini++;
    }
    if (maksi == mini)
        brojmini=0;
    rez = razlika(maksi,mini);
    for (int p = 0; p<bira-2;p++)
    {
        racunanjekrozniz(niz,n,maksi,mini, brojmaksi, brojmini, rez, maksirazlika);

    }
    cout << rez <<endl;

}